name: Tests

on:
  push:
  pull_request:
  schedule:
    - cron: '0 4 * * *'

jobs:
  tests:
    runs-on: ubuntu-22.04
    timeout-minutes: 10

    strategy:
      fail-fast: true

    name: PHP 8.1

    steps:
      - name: Checkout
        uses: actions/checkout@v3

      - name: Install postfix
        run: sudo apt-get install -y postfix

      - name: Setup PHP
        uses: shivammathur/setup-php@v2
        with:
          php-version: 8.1
          tools: composer
          coverage: xdebug

      - name: Install dependencies
        env:
          COMPOSER_ROOT_VERSION: dev-master
        run:
          composer update

      - name: Composer normalize
        run:
          composer normalize --dry-run --indent-size=4 --indent-style=space

      - name: Coding Standard
        run:
          vendor/bin/php-cs-fixer fix --diff --dry-run --verbose

      # - name: PHPMD
      # run:
      #   vendor/bin/phpmd src xml phpmd.xml

      - name: PHPStan
        run:
          vendor/bin/phpstan analyse -vvv

      - name: PHPUnit
        run: vendor/bin/phpunit --verbose

      - name: Upload coverage results to Coveralls
        env:
          COVERALLS_REPO_TOKEN: ${{ secrets.GITHUB_TOKEN }}
        run: |
          mkdir -p build/logs/
          cp build/coverage/clover.xml build/logs/clover.xml
          composer global require php-coveralls/php-coveralls
          php-coveralls --coverage_clover=build/logs/clover.xml -v

  tests-last:
    runs-on: ubuntu-22.04
    timeout-minutes: 10

    strategy:
      fail-fast: true

    name: PHP 8.2 - Last

    steps:
      - name: Checkout
        uses: actions/checkout@v3

      - name: Install postfix
        run: sudo apt-get install -y postfix

      - name: Setup PHP
        uses: shivammathur/setup-php@v2
        with:
          php-version: 8.2
          tools: composer
          coverage: xdebug

      - name: Install dependencies
        env:
          COMPOSER_ROOT_VERSION: dev-master
        run:
          composer update

      - name: PHPUnit
        run: vendor/bin/phpunit --verbose
